libretools - Bug #20

[fullpkg-find] rewrite order creation
2012-02-27 06:44 PM - mtjm

Status: not-a-bug % Done: 0%
Priority: bug

Assignee: mtjm

Category:

Description

Use a depth first search of a directed acyclic graph (while checking that it has no cycles). Don't assume that it's a tree (it isn't, there
are examples for this in abslibre-mips64el), don't count depths in the graph (they are useful only when showing it, but this assumes it
being a tree).

Related issues:
Related to libretools - Bug #24: [fullpkg] and [treepkg] solve the same problem fixed 2012-02-27

History

#4 - 2013-06-07 01:56 AM - mtjm

| believe it's more important than a "wish" and | can do it (not before exams).

This occurred recently: a new ruby version with new soname was available, and a new graphviz version. This is the dependency graph:

graphviz -> ruby -> graphviz

fullpkg decided to build graphviz first, then ruby, thus making the graphviz Ruby binding not work: it needed the version of ruby available when it was
built.

Running fullpkg on ruby instead of graphviz would make the other order, so it cannot be decided correctly by the script.

| believe this should be decided manually by the user, with fullpkg detecting the cycle and failing. (The real solution in this case was to build ruby
ignoring the graphviz update, or build graphviz twice, releasing the new one only.)

Other situation where this is useful:

a->b ->d
a —> c

if d fails to build, it's still possible to build c, fullpkg currently won't do it.

#5 - 2014-01-15 04:19 PM - fauno
- Related to Bug #24: [fullpkg] and [treepkg] solve the same problem added

#6 - 2014-12-26 02:51 PM - mtjm

- Status changed from open to not-a-bug

dagpkg will solve this, #504.
